diff --git tests/cefclient/CMakeLists.txt.in tests/cefclient/CMakeLists.txt.in
index bf17d06b..2cd49c5b 100644
--- tests/cefclient/CMakeLists.txt.in
+++ tests/cefclient/CMakeLists.txt.in
@@ -248,7 +248,7 @@ if(OS_WINDOWS)
   add_executable(${CEF_TARGET} WIN32 ${CEFCLIENT_SRCS})
   SET_EXECUTABLE_TARGET_PROPERTIES(${CEF_TARGET})
   add_dependencies(${CEF_TARGET} libcef_dll_wrapper)
-  target_link_libraries(${CEF_TARGET} libcef_lib libcef_dll_wrapper ${CEF_STANDARD_LIBS} glu32.lib imm32.lib opengl32.lib)
+  target_link_libraries(${CEF_TARGET} libcef_lib libcef_dll_wrapper ${CEF_STANDARD_LIBS} d3d11.lib glu32.lib imm32.lib opengl32.lib)
 
   if(USE_ATL)
     # Required by VS2013 to link accessibility API functions.
diff --git tests/cefclient/browser/browser_window_osr_gtk.cc tests/cefclient/browser/browser_window_osr_gtk.cc
index 0d4a7846..44701f3e 100644
--- tests/cefclient/browser/browser_window_osr_gtk.cc
+++ tests/cefclient/browser/browser_window_osr_gtk.cc
@@ -928,7 +928,7 @@ class ScopedGLContext {
 
 BrowserWindowOsrGtk::BrowserWindowOsrGtk(BrowserWindow::Delegate* delegate,
                                          const std::string& startup_url,
-                                         const OsrRenderer::Settings& settings)
+                                         const OsrRendererSettings& settings)
     : BrowserWindow(delegate),
       renderer_(settings),
       glarea_(NULL),
diff --git tests/cefclient/browser/browser_window_osr_gtk.h tests/cefclient/browser/browser_window_osr_gtk.h
index e52feb61..a7fb76d0 100644
--- tests/cefclient/browser/browser_window_osr_gtk.h
+++ tests/cefclient/browser/browser_window_osr_gtk.h
@@ -22,7 +22,7 @@ class BrowserWindowOsrGtk : public BrowserWindow,
   // |delegate| must outlive this object.
   BrowserWindowOsrGtk(BrowserWindow::Delegate* delegate,
                       const std::string& startup_url,
-                      const OsrRenderer::Settings& settings);
+                      const OsrRendererSettings& settings);
 
   // BrowserWindow methods.
   void CreateBrowser(ClientWindowHandle parent_handle,
diff --git tests/cefclient/browser/browser_window_osr_mac.h tests/cefclient/browser/browser_window_osr_mac.h
index 7dcbd333..5300e990 100644
--- tests/cefclient/browser/browser_window_osr_mac.h
+++ tests/cefclient/browser/browser_window_osr_mac.h
@@ -23,7 +23,7 @@ class BrowserWindowOsrMac : public BrowserWindow,
   // |delegate| must outlive this object.
   BrowserWindowOsrMac(BrowserWindow::Delegate* delegate,
                       const std::string& startup_url,
-                      const OsrRenderer::Settings& settings);
+                      const OsrRendererSettings& settings);
   ~BrowserWindowOsrMac();
 
   // BrowserWindow methods.
diff --git tests/cefclient/browser/browser_window_osr_mac.mm tests/cefclient/browser/browser_window_osr_mac.mm
index 66a036cf..ef8c2a71 100644
--- tests/cefclient/browser/browser_window_osr_mac.mm
+++ tests/cefclient/browser/browser_window_osr_mac.mm
@@ -1208,7 +1208,7 @@ namespace client {
 
 BrowserWindowOsrMac::BrowserWindowOsrMac(BrowserWindow::Delegate* delegate,
                                          const std::string& startup_url,
-                                         const OsrRenderer::Settings& settings)
+                                         const OsrRendererSettings& settings)
     : BrowserWindow(delegate),
       renderer_(settings),
       nsview_(NULL),
diff --git tests/cefclient/browser/browser_window_osr_win.cc tests/cefclient/browser/browser_window_osr_win.cc
index 2b1851fb..44573291 100644
--- tests/cefclient/browser/browser_window_osr_win.cc
+++ tests/cefclient/browser/browser_window_osr_win.cc
@@ -10,7 +10,7 @@ namespace client {
 
 BrowserWindowOsrWin::BrowserWindowOsrWin(BrowserWindow::Delegate* delegate,
                                          const std::string& startup_url,
-                                         const OsrRenderer::Settings& settings)
+                                         const OsrRendererSettings& settings)
     : BrowserWindow(delegate), osr_hwnd_(NULL), device_scale_factor_(0) {
   osr_window_ = new OsrWindowWin(this, settings);
   client_handler_ = new ClientHandlerOsr(this, osr_window_.get(), startup_url);
@@ -36,6 +36,11 @@ void BrowserWindowOsrWin::GetPopupConfig(CefWindowHandle temp_handle,
   CEF_REQUIRE_UI_THREAD();
 
   windowInfo.SetAsWindowless(temp_handle);
+  windowInfo.shared_texture_enabled =
+      osr_window_->settings().shared_texture_enabled;
+  windowInfo.external_begin_frame_enabled =
+      osr_window_->settings().external_begin_frame_enabled;
+
   client = client_handler_;
 }
 
diff --git tests/cefclient/browser/browser_window_osr_win.h tests/cefclient/browser/browser_window_osr_win.h
index 9064796f..3fce9e2f 100644
--- tests/cefclient/browser/browser_window_osr_win.h
+++ tests/cefclient/browser/browser_window_osr_win.h
@@ -21,7 +21,7 @@ class BrowserWindowOsrWin : public BrowserWindow,
   // |delegate| must outlive this object.
   BrowserWindowOsrWin(BrowserWindow::Delegate* delegate,
                       const std::string& startup_url,
-                      const OsrRenderer::Settings& settings);
+                      const OsrRendererSettings& settings);
 
   // BrowserWindow methods.
   void CreateBrowser(ClientWindowHandle parent_handle,
diff --git tests/cefclient/browser/client_handler.cc tests/cefclient/browser/client_handler.cc
index c68d9339..39e40882 100644
--- tests/cefclient/browser/client_handler.cc
+++ tests/cefclient/browser/client_handler.cc
@@ -831,6 +831,8 @@ void ClientHandler::ShowDevTools(CefRefPtr<CefBrowser> browser,
   CefRefPtr<CefClient> client;
   CefBrowserSettings settings;
 
+  MainContext::Get()->PopulateBrowserSettings(&settings);
+
   CefRefPtr<CefBrowserHost> host = browser->GetHost();
 
   // Test if the DevTools browser already exists.
diff --git tests/cefclient/browser/client_handler_osr.cc tests/cefclient/browser/client_handler_osr.cc
index a2a2863f..5b147f99 100644
--- tests/cefclient/browser/client_handler_osr.cc
+++ tests/cefclient/browser/client_handler_osr.cc
@@ -104,6 +104,17 @@ void ClientHandlerOsr::OnPaint(CefRefPtr<CefBrowser> browser,
   osr_delegate_->OnPaint(browser, type, dirtyRects, buffer, width, height);
 }
 
+void ClientHandlerOsr::OnAcceleratedPaint(
+    CefRefPtr<CefBrowser> browser,
+    CefRenderHandler::PaintElementType type,
+    const CefRenderHandler::RectList& dirtyRects,
+    void* share_handle) {
+  CEF_REQUIRE_UI_THREAD();
+  if (!osr_delegate_)
+    return;
+  osr_delegate_->OnAcceleratedPaint(browser, type, dirtyRects, share_handle);
+}
+
 void ClientHandlerOsr::OnCursorChange(CefRefPtr<CefBrowser> browser,
                                       CefCursorHandle cursor,
                                       CursorType type,
diff --git tests/cefclient/browser/client_handler_osr.h tests/cefclient/browser/client_handler_osr.h
index 42723102..35627aba 100644
--- tests/cefclient/browser/client_handler_osr.h
+++ tests/cefclient/browser/client_handler_osr.h
@@ -39,11 +39,16 @@ class ClientHandlerOsr : public ClientHandler,
     virtual void OnPopupSize(CefRefPtr<CefBrowser> browser,
                              const CefRect& rect) = 0;
     virtual void OnPaint(CefRefPtr<CefBrowser> browser,
-                         PaintElementType type,
-                         const RectList& dirtyRects,
+                         CefRenderHandler::PaintElementType type,
+                         const CefRenderHandler::RectList& dirtyRects,
                          const void* buffer,
                          int width,
                          int height) = 0;
+    virtual void OnAcceleratedPaint(
+        CefRefPtr<CefBrowser> browser,
+        CefRenderHandler::PaintElementType type,
+        const CefRenderHandler::RectList& dirtyRects,
+        void* share_handle) {}
     virtual void OnCursorChange(CefRefPtr<CefBrowser> browser,
                                 CefCursorHandle cursor,
                                 CefRenderHandler::CursorType type,
@@ -103,6 +108,10 @@ class ClientHandlerOsr : public ClientHandler,
                const void* buffer,
                int width,
                int height) OVERRIDE;
+  void OnAcceleratedPaint(CefRefPtr<CefBrowser> browser,
+                          CefRenderHandler::PaintElementType type,
+                          const CefRenderHandler::RectList& dirtyRects,
+                          void* share_handle) OVERRIDE;
   void OnCursorChange(CefRefPtr<CefBrowser> browser,
                       CefCursorHandle cursor,
                       CursorType type,
diff --git tests/cefclient/browser/main_context.h tests/cefclient/browser/main_context.h
index b1db6b8f..c7b04cd9 100644
--- tests/cefclient/browser/main_context.h
+++ tests/cefclient/browser/main_context.h
@@ -10,10 +10,16 @@
 
 #include "include/base/cef_ref_counted.h"
 #include "include/internal/cef_types_wrappers.h"
-#include "tests/cefclient/browser/osr_renderer.h"
+#include "tests/cefclient/browser/osr_renderer_settings.h"
 
 namespace client {
 
+#if defined(OS_WIN)
+namespace d3d11 {
+class Device;
+}
+#endif
+
 class RootWindowManager;
 
 // Used to store global context in the browser process. The methods of this
@@ -47,11 +53,15 @@ class MainContext {
   // Populate |settings| based on command-line arguments.
   virtual void PopulateSettings(CefSettings* settings) = 0;
   virtual void PopulateBrowserSettings(CefBrowserSettings* settings) = 0;
-  virtual void PopulateOsrSettings(OsrRenderer::Settings* settings) = 0;
+  virtual void PopulateOsrSettings(OsrRendererSettings* settings) = 0;
 
   // Returns the object used to create/manage RootWindow instances.
   virtual RootWindowManager* GetRootWindowManager() = 0;
 
+#if defined(OS_WIN)
+  virtual std::shared_ptr<d3d11::Device> GetD3D11Device() = 0;
+#endif
+
  protected:
   MainContext();
   virtual ~MainContext();
diff --git tests/cefclient/browser/main_context_impl.cc tests/cefclient/browser/main_context_impl.cc
index 5ccedae7..ba6fb625 100644
--- tests/cefclient/browser/main_context_impl.cc
+++ tests/cefclient/browser/main_context_impl.cc
@@ -46,6 +46,7 @@ MainContextImpl::MainContextImpl(CefRefPtr<CefCommandLine> command_line,
       shutdown_(false),
       background_color_(0),
       browser_background_color_(0),
+      windowless_frame_rate_(0),
       use_views_(false) {
   DCHECK(command_line_.get());
 
@@ -59,11 +60,35 @@ MainContextImpl::MainContextImpl(CefRefPtr<CefCommandLine> command_line,
   use_windowless_rendering_ =
       command_line_->HasSwitch(switches::kOffScreenRenderingEnabled);
 
+  if (use_windowless_rendering_ &&
+      command_line_->HasSwitch(switches::kOffScreenFrameRate)) {
+    windowless_frame_rate_ =
+        atoi(command_line_->GetSwitchValue(switches::kOffScreenFrameRate)
+                 .ToString()
+                 .c_str());
+  }
+
   // Whether transparent painting is used with windowless rendering.
   const bool use_transparent_painting =
       use_windowless_rendering_ &&
       command_line_->HasSwitch(switches::kTransparentPaintingEnabled);
 
+#if defined(OS_WIN)
+  // Shared texture is only supported on Windows.
+  shared_texture_enabled_ =
+      use_windowless_rendering_ &&
+      command_line_->HasSwitch(switches::kSharedTextureEnabled);
+#endif
+
+  external_begin_frame_enabled_ =
+      use_windowless_rendering_ &&
+      command_line_->HasSwitch(switches::kExternalBeginFrameEnabled);
+
+  if (windowless_frame_rate_ <= 0) {
+    // Choose a reasonable default rate based on the OSR mode.
+    windowless_frame_rate_ = shared_texture_enabled_ ? 60 : 30;
+  }
+
 #if defined(OS_WIN) || defined(OS_LINUX)
   // Whether the Views framework will be used.
   use_views_ = command_line_->HasSwitch(switches::kUseViews);
@@ -156,21 +181,22 @@ void MainContextImpl::PopulateSettings(CefSettings* settings) {
 }
 
 void MainContextImpl::PopulateBrowserSettings(CefBrowserSettings* settings) {
-  if (command_line_->HasSwitch(switches::kOffScreenFrameRate)) {
-    settings->windowless_frame_rate =
-        atoi(command_line_->GetSwitchValue(switches::kOffScreenFrameRate)
-                 .ToString()
-                 .c_str());
-  }
+  settings->windowless_frame_rate = windowless_frame_rate_;
 
   if (browser_background_color_ != 0)
     settings->background_color = browser_background_color_;
 }
 
-void MainContextImpl::PopulateOsrSettings(OsrRenderer::Settings* settings) {
+void MainContextImpl::PopulateOsrSettings(OsrRendererSettings* settings) {
   settings->show_update_rect =
       command_line_->HasSwitch(switches::kShowUpdateRect);
 
+#if defined(OS_WIN)
+  settings->shared_texture_enabled = shared_texture_enabled_;
+#endif
+  settings->external_begin_frame_enabled = external_begin_frame_enabled_;
+  settings->begin_frame_rate = windowless_frame_rate_;
+
   if (browser_background_color_ != 0)
     settings->background_color = browser_background_color_;
 }
diff --git tests/cefclient/browser/main_context_impl.h tests/cefclient/browser/main_context_impl.h
index a58784ca..c7a1d837 100644
--- tests/cefclient/browser/main_context_impl.h
+++ tests/cefclient/browser/main_context_impl.h
@@ -31,9 +31,13 @@ class MainContextImpl : public MainContext {
   bool UseWindowlessRendering() OVERRIDE;
   void PopulateSettings(CefSettings* settings) OVERRIDE;
   void PopulateBrowserSettings(CefBrowserSettings* settings) OVERRIDE;
-  void PopulateOsrSettings(OsrRenderer::Settings* settings) OVERRIDE;
+  void PopulateOsrSettings(OsrRendererSettings* settings) OVERRIDE;
   RootWindowManager* GetRootWindowManager() OVERRIDE;
 
+#if defined(OS_WIN)
+  std::shared_ptr<d3d11::Device> GetD3D11Device() OVERRIDE;
+#endif
+
   // Initialize CEF and associated main context state. This method must be
   // called on the same thread that created this object.
   bool Initialize(const CefMainArgs& args,
@@ -68,10 +72,17 @@ class MainContextImpl : public MainContext {
   cef_color_t background_color_;
   cef_color_t browser_background_color_;
   bool use_windowless_rendering_;
+  int windowless_frame_rate_;
   bool use_views_;
 
   scoped_ptr<RootWindowManager> root_window_manager_;
 
+#if defined(OS_WIN)
+  bool shared_texture_enabled_;
+  bool external_begin_frame_enabled_;
+  std::shared_ptr<d3d11::Device> d3d11_device_;
+#endif
+
   // Used to verify that methods are called on the correct thread.
   base::ThreadChecker thread_checker_;
 
diff --git tests/cefclient/browser/main_context_impl_win.cc tests/cefclient/browser/main_context_impl_win.cc
index 4bf4d588..d52c0943 100644
--- tests/cefclient/browser/main_context_impl_win.cc
+++ tests/cefclient/browser/main_context_impl_win.cc
@@ -7,6 +7,8 @@
 #include <direct.h>
 #include <shlobj.h>
 
+#include "tests/cefclient/browser/osr_d3d11_win.h"
+
 namespace client {
 
 std::string MainContextImpl::GetDownloadPath(const std::string& file_name) {
@@ -36,4 +38,11 @@ std::string MainContextImpl::GetAppWorkingDirectory() {
   return szWorkingDir;
 }
 
+std::shared_ptr<d3d11::Device> MainContextImpl::GetD3D11Device() {
+  CEF_REQUIRE_UI_THREAD();
+  if (!d3d11_device_)
+    d3d11_device_ = d3d11::Device::create();
+  return d3d11_device_;
+}
+
 }  // namespace client
